﻿using System;
using PaxScript.Net;

namespace ConsoleApp
{
    class Program
    {
        static void Main(string[] args)
        {
            PaxScripter paxScripter1 = new PaxScript.Net.PaxScripter(null);
            paxScripter1.AddModule("1");
            paxScripter1.AddCodeLine("1", @"Console.WriteLine(""Hello world"");");
            paxScripter1.Run(RunMode.Run);
            if (paxScripter1.HasErrors)
            {
                foreach (ScriptError err in paxScripter1.Error_List)
                    Console.WriteLine("Error: " + err.Message);
            }

            Console.WriteLine("Press any key...");
            Console.ReadKey();
        }
    }
}
