﻿using System;
using System.Collections.Generic;
using PaxScript.Net;


namespace Generic1
{
    class Program
    {
        static void Main(string[] args)
        { 
            PaxScripter scripter = new PaxScripter(null);
            scripter.RegisterType(typeof(Dictionary<string, string>));

            scripter.AddModule("1");
            scripter.AddCodeLine("1", @"Dictionary<string, string> dictTest = new Dictionary<string, string>();");
            scripter.AddCodeLine("1", @"dictTest.Add(""test"", ""testing..."");");
            scripter.AddCodeLine("1", @"Console.WriteLine(dictTest[""test""]);");
            scripter.Run(RunMode.Run);

            foreach (ScriptError err in scripter.Error_List)
            {
                Console.WriteLine(string.Format("Error: {0}. Line {1}/{2}:\n {3}",
                err.Message,
                err.LineNumber,
                err.PCodeLineNumber,
                err.Line));
            }

            Console.WriteLine("Press any key...");
            Console.ReadKey();
        }
    }
}
