﻿using System;
using PaxScript.Net;

namespace Generic3
{
    class Program
    {
        static void Main(string[] args)
        {
            PaxScripter paxScripter1 = new PaxScript.Net.PaxScripter(null);
            paxScripter1.AddModule("1");

            paxScripter1.AddCodeLine("1", @"using System;");

            // Script-defined generic type
            paxScripter1.AddCodeLine("1", @"public class GFG<T>");
            paxScripter1.AddCodeLine("1", @"{");
            paxScripter1.AddCodeLine("1", @"    private T data;");

            paxScripter1.AddCodeLine("1", @"    public T value");
            paxScripter1.AddCodeLine("1", @"    {");
            paxScripter1.AddCodeLine("1", @"        get");
            paxScripter1.AddCodeLine("1", @"        {");
            paxScripter1.AddCodeLine("1", @"            return this.data;");
            paxScripter1.AddCodeLine("1", @"        }");
            paxScripter1.AddCodeLine("1", @"        set");
            paxScripter1.AddCodeLine("1", @"        {");
            paxScripter1.AddCodeLine("1", @"            this.data = value;");
            paxScripter1.AddCodeLine("1", @"        }");
            paxScripter1.AddCodeLine("1", @"    }");
            paxScripter1.AddCodeLine("1", @"}");

            // Driver class
            paxScripter1.AddCodeLine("1", @"class Test");
            paxScripter1.AddCodeLine("1", @"{");

            // Main method
            paxScripter1.AddCodeLine("1", @"    static void Main(string[] args)");
            paxScripter1.AddCodeLine("1", @"    {");

            // instance of string type
            paxScripter1.AddCodeLine("1", @"        GFG<string> name = new GFG<string>();");
            paxScripter1.AddCodeLine("1", @"        name.value = ""GeeksforGeeks"";");

            // display GeeksforGeeks
            paxScripter1.AddCodeLine("1", @"        Console.WriteLine(name.value);");
            paxScripter1.AddCodeLine("1", @"    }");
            paxScripter1.AddCodeLine("1", @"}");
            
            paxScripter1.Run(RunMode.Run);
            if (paxScripter1.HasErrors)
            {
                foreach (ScriptError err in paxScripter1.Error_List)
                    Console.WriteLine("Error: " + err.Message);
            }

            Console.WriteLine("Press any key...");
            Console.ReadKey();
        }
    }
}
