﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PaxScript.Net;


namespace Hello
{
    public partial class Form1 : Form
    {
        private PaxScript.Net.PaxScripter paxScripter1;

        public Form1()
        {
            InitializeComponent();
            paxScripter1 = new PaxScript.Net.PaxScripter(this.components);

        }

        private void button1_Click(object sender, EventArgs e)
        {
            paxScripter1.RegisterInstance("button1", button1);
            paxScripter1.AddModule("1");
            paxScripter1.AddCode("1", @"button1.Text = ""Hello"";");
            paxScripter1.Run(RunMode.Run);
            if (paxScripter1.HasErrors)
            {
                foreach (ScriptError err in paxScripter1.Error_List)
                    MessageBox.Show("Error: " + err.Message);
            }
            paxScripter1.Reset();
        }
    }
}
