using System;
public class TestDelegates
{
	delegate void D(int x);

	public class MyClass
	{
		static int z = 50;

		public void Proc1(int x)
		{
			Console.WriteLine(x);
		}

		public void Proc2(int x)
		{
			Console.WriteLine(x + x);
		}

		public static void StaticProc(int x)
		{
			Console.WriteLine(z + x);
		}
	}

	public static void Main()
	{
		MyClass v = new MyClass();
		D d, d1, d2, d3;

		d1 = new D(v.Proc1);
		d2 = new D(v.Proc2);
		d3 = new D(MyClass.StaticProc);
		d += d2;
		d(700);

		d = d1 + d2 + d3;

		d(100);
	}
}
