using System;
using System.Windows.Forms;

public class TestClass
{
	public void TestClass_OnClick(object sender, EventArgs e)
	{
		MessageBox.Show("instance method");
		MessageBox.Show(sender.ToString());
		MessageBox.Show(e.ToString());
	}
}

public class MainWindow: Form
{
	Button button = new Button();
	TestClass t = new TestClass();

	public MainWindow()
	{
		Text = "Test form";

		button.Text = "Click me";
		button.Click += new EventHandler(Form_OnClick); // static method
		button.Click += new EventHandler(t.TestClass_OnClick); // instance method

		Controls.Add(button);
	}

	public static void Main()
	{
		Application.Run(new MainWindow());
	}

	static void Form_OnClick(object sender, EventArgs e)
	{
		MessageBox.Show("static method");
		MessageBox.Show(sender.ToString());
		MessageBox.Show(e.ToString());
	}
}
