Imports System
Imports System.Collections.Generic
Imports PaxScript.Net


Module Program
    Sub Main(args As String())
        Dim paxScripter1 As PaxScripter = New PaxScript.Net.PaxScripter()
        Dim err As ScriptError

        Dim dictTest As Dictionary(Of String, String) = New Dictionary(Of String, String)
        dictTest.Add("test", "testing...")

        paxScripter1.RegisterInstance("dictTest", dictTest)
        paxScripter1.AddModule("1", "VB")
        paxScripter1.AddCode("1", "Console.WriteLine(dictTest(""test""))")
        paxScripter1.Run(RunMode.Run)
        If paxScripter1.HasErrors Then
            For Each Err In paxScripter1.Error_List
                Console.WriteLine("Error: " + Err.Message)
            Next
        End If

        Console.WriteLine("Press any key...")
        Console.ReadKey()
    End Sub
End Module
