﻿using System;
using System.Collections.Generic;
using PaxScript.Net;

namespace RegisterInstance
{
    class Program
    {
        static void Main(string[] args)
        {
            Dictionary<string, string> dictTest = new Dictionary<string, string>();
            dictTest.Add("test", "testing...");

            PaxScripter scripter = new PaxScripter(null);
            scripter.RegisterInstance("dictTest", dictTest);

            scripter.AddModule("1");
            scripter.AddCode("1", @"Console.WriteLine(dictTest[""test""]);");
            scripter.Run(RunMode.Run);

            foreach (ScriptError err in scripter.Error_List)
            {
                Console.WriteLine(string.Format("Error: {0}. Line {1}/{2}:\n {3}",
                err.Message,
                err.LineNumber,
                err.PCodeLineNumber,
                err.Line));
            }

            Console.WriteLine("Press any key...");
            Console.ReadKey();
        }
    }
}
