using System;

class TimeSpan
{
	private uint totalSeconds;

	public TimeSpan(uint initialTotalSeconds)
	{
		totalSeconds = initialTotalSeconds;
	}

	public uint TotalSeconds
	{
		get
		{
			return totalSeconds;
		}
	}

	public void PrintSeconds()
	{
		Console.WriteLine("Total seconds: {0}", totalSeconds);
	}

	public static implicit operator TimeSpan(uint convertFrom)
	{
		TimeSpan newTimeSpan;

		newTimeSpan = new TimeSpan(convertFrom);
		Console.WriteLine("Converting from uint to TimeSpan");
		return newTimeSpan;
	}

	public static implicit operator uint(TimeSpan convertFrom)
	{
		Console.WriteLine("Converting from TimeSpan to uint");
		return convertFrom.TotalSeconds;
	}
}

class ImplicitConversionTester
{
	public static void Main()
	{
		uint simpleTimeSeconds = 30;
		TimeSpan myTime;

		myTime = simpleTimeSeconds;
		myTime.PrintSeconds();

		simpleTimeSeconds = myTime;
		Console.WriteLine("simple total seconds: {0}", simpleTimeSeconds);
	}
}