using System;

public struct Complex
{
	public int re, im;


	public Complex(int re, int im)
	{
		this.re = re;
		this.im = im;
	}

	public static Complex operator + (Complex x, Complex y)
	{
		return new Complex(x.re + y.re, x.im + y.im);
	}

	public static Complex operator - (Complex x)
	{
		return new Complex(- x.re, - x.im);
	}
}

public class TestOperatorOverloading
{
        public static void Main()
        {  
               Complex cx = new Complex(10, 20);
               Complex cy = new Complex(40, 50);
               Complex cz = cx + cy;
               println cz.re;
               println cz.im;
               cz = - cz;
               println cz.re;
               println cz.im; 
        }
}
